#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include "config.h"
#include "memory.h"

HostPt MemBase;

void MEM_Init(Bitu memsize) {
	MemBase = new Bit8u[memsize*1024*1024];
		if (!MemBase) 
		{
			printf("Can't allocate main memory of %d MB",memsize);
			exit(EXIT_FAILURE);
		}
		/* Clear the memory, as new doesn't always give zeroed memory
		 * (Visual C debug mode). We want zeroed memory though. */
		memset((void*)MemBase,0,memsize*1024*1024);
}